unit Unit11;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, ExtCtrls,
  UnitV ;

type
  TForm11 = class(TForm)
    SG1: TStringGrid;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Panel1: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label2: TLabel;
    Edit3: TEdit;
    ComboBox1: TComboBox;
    Label5: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SG1Click(Sender: TObject);
    procedure Edit1DblClick(Sender: TObject);
    procedure Edit3DblClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private 錾 }
    procedure TableDisplay ;
  public
    { Public 錾 }
    P_CODE1 : integer ;
    P_CODE2 : integer ;
  end;

var
  Form11: TForm11;

implementation

uses
   Unit1 ;

{$R *.dfm}

// N
procedure TForm11.FormShow(Sender: TObject);
var
   i,n : integer ;
   s : array of string ;
begin
   with SG1 do begin
      RowCount := 2 ;
      Cells[0,0] := 'ԍ';
      Cells[1,0] := 'e';
      Cells[2,0] := 'Ҕԍ';
      Cells[3,0] := 't';
      for i:=0 to ColCount-1 do
         Cells[i,1] := '' ;
   end;
   if (Trim(DBfold) = '')or(Trim(DBname) = '') then begin
      ShowMessage('ŏɃf[^x[X̐ݒsĉB');
      close ;
      exit ;
   end;
   // ڑ`FbNiꉞj
   if not(Form1.IBDatabase1.Connected) then begin
      ShowMessage('f[^x[Xɐڑo܂BݒmFĉB');
      close ;
      exit ;
   end;
   // e[u Form1 ĂяoOɍ쐬ς

   // o[e[uComboBox1
   ComboBox1.Items.Clear ;
   ComboBox1.Items.Add('0:w薳');
   if (Form1.DataTableCheck(TABLE2)) then begin
      n := Form1.TableRef('*',TABLE2,'','N');
      SetLength(s,TABLE2N);
      for i:=1 to n do begin
         if (i = 1) then
            Form1.TableFirst(s)
         else
            Form1.TableNext(s);
         ComboBox1.Items.Add(s[0]+':'+s[2]);
      end;
      Form1.TableClose ;
      s := nil;
   end;
   ComboBox1.ItemIndex := 0 ;

   // e[uQƁEꗗ\
   TableDisplay ;

   SG1.SetFocus ;
end;

// I
procedure TForm11.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   //
end;

// e[uQƁEꗗ\
procedure TForm11.TableDisplay ;
var
   i,n : integer ;
   t,w : string ;
   s : array of string ;
begin
   SG1.RowCount := 2 ;
   for i:=0 to SG1.ColCount-1 do
      SG1.Cells[i,1] := '' ;

   t := TABLE6 ;
   w := 'ZN=' + IntToStr(P_CODE2) ;

   n := Form1.TableRef('*',t,w,'N');
   if (n > 0) then
      SG1.RowCount := n+1 ;

   SetLength(s,TABLE6N);

   for i:=1 to n do begin
      with SG1 do begin
         if (i = 1) then
            Form1.TableFirst(s)
         else
            Form1.TableNext(s);
         //
         Cells[0,i] := s[0] ;
         Cells[1,i] := s[2] ;
         Cells[2,i] := s[3] ;
         Cells[3,i] := s[4] ;
      end;
   end;
   Form1.TableClose ;

   s := nil;
end;

// \NbN
procedure TForm11.SG1Click(Sender: TObject);
var
   i,j,k : integer ;
   s : string ;
begin
   i := SG1.Row ;
   s := SG1.Cells[0,i] ;
   if (s = '') then exit ;
   Edit1.Text := s ;
   Edit2.Text := SG1.Cells[1,i] ;
   Edit3.Text := SG1.Cells[3,i] ;
   j := SInt(SG1.Cells[2,i]);
   with ComboBox1 do begin
      ItemIndex := 0 ;
      for i:=1 to Items.Count-1 do begin
         k := SInt(GetStrCode(Items[i])) ;
         if (j = k) then begin
            ItemIndex := i ;
            break ;
         end;
      end;
   end;
end;

// ԍŃ_uNbNŏIԍ+1
procedure TForm11.Edit1DblClick(Sender: TObject);
var
   t : string ;
   n : integer ;
begin
   t := TABLE6 ;
   n := SInt(Form1.GetMaxValue(t,'N',''));
   Edit1.Text := IntToStr(n+1);
end;

// tŃ_uNbN̓t
procedure TForm11.Edit3DblClick(Sender: TObject);
begin
   ShortDateFormat := 'yyyymmdd';
   Edit3.Text := DateToStr(Now);
end;

// o^
procedure TForm11.Button1Click(Sender: TObject);
var
   n,rn,i : integer ;
   t : string ;
   fs: array of string ;
   s : array of string ;
begin
   if (Trim(Edit1.Text) = '') then begin
      ShowMessage('ԍ͂ĉi̐ĺj');
      Edit1.SetFocus ;
      exit ;
   end;
   n := SInt(Edit1.Text) ;
   if (n <= 0) then begin
      ShowMessage('ԍ͐̐œ͂ĉ');
      Edit1.SetFocus ;
      exit ;
   end;
   if (Edit3.Text <> '') then begin
      if not(CheckDate(Edit3.Text)) then begin
         ShowMessage('t yyyymmdd`iF20100101jŗLȓe͂ĉB');
         Edit3.SetFocus ;
         exit ;
      end;
   end;
   if (AnsiPos('''',Edit2.Text) > 0) or (AnsiPos('"',Edit2.Text) > 0) then begin
      ShowMessage('pu''vu"v͂Ȃŉ');
      Edit2.SetFocus;
      exit;
   end;
   t := TABLE6 ;
   i := ComboBox1.ItemIndex ;
   rn:= SInt(GetStrCode(ComboBox1.Items[i]));

   SetLength(fs,TABLE6N);
   SetLength(s ,TABLE6N);

   fs[0] := 'N';
   fs[1] := 'ZN';
   fs[2] := 'CONT';
   fs[3] := 'RN';
   fs[4] := 'RDATE';

   s[0] := IntToStr(n) ;
   s[1] := IntToStr(P_CODE2) ;
   s[2] := Edit2.Text ;
   s[3] := IntToStr(rn) ;
   s[4] := Edit3.Text ;

   for i:=2 to 4 do begin
      if (i = 3) then continue ;
      if (s[i] = '') then
         s[i] := 'NULL'
      else
         s[i] := '''' + s[i] + '''' ;
   end;

   if (Form1.TableAdd(t,TABLE6N,fs,s)) then begin
      ShowMessage('o^OK');
   end
   else begin
      ShowMessage('o^s');
   end;

   fs := nil ;
   s  := nil ;

   TableDisplay ;
end;

// 폜
procedure TForm11.Button2Click(Sender: TObject);
var
   i : integer ;
   t,s : string ;
begin
   i := SG1.Row ;
   s := SG1.Cells[0,i] ;
   if (s = '') then exit ;
   s := 'No.' + s + 'F' + SG1.Cells[1,i] ;
   if MessageDlg('u'+s+'v폜܂B' + #13 + #10 + '낵łH',
      mtConfirmation, [mbYes, mbNo], 0) = mrNo then exit ;
   //
   s := SG1.Cells[0,i] ;
   i := SInt(s);
   t := TABLE6 ;
   if (Form1.TableDel(t,'N='+IntToStr(i))) then begin
      ShowMessage('폜OK');
   end
   else begin
      ShowMessage('폜s');
   end;
   //
   TableDisplay ;
end;

// 
procedure TForm11.Button3Click(Sender: TObject);
begin
   close;
end;

// ύX
procedure TForm11.Button4Click(Sender: TObject);
var
   n,rn,i : integer ;
   t,w : string ;
   fs: array of string ;
   s : array of string ;
begin
   if (Trim(Edit1.Text) = '') then begin
      ShowMessage('ԍ͂ĉi̐ĺj');
      Edit1.SetFocus ;
      exit ;
   end;
   n := SInt(Edit1.Text) ;
   if (n <= 0) then begin
      ShowMessage('ԍ͐̐œ͂ĉ');
      Edit1.SetFocus ;
      exit ;
   end;
   if (Edit3.Text <> '') then begin
      if not(CheckDate(Edit3.Text)) then begin
         ShowMessage('t yyyymmdd`iF20100101jŗLȓe͂ĉB');
         Edit3.SetFocus ;
         exit ;
      end;
   end;
   if (AnsiPos('''',Edit2.Text) > 0) or (AnsiPos('"',Edit2.Text) > 0) then begin
      ShowMessage('pu''vu"v͂Ȃŉ');
      Edit2.SetFocus;
      exit;
   end;
   t := TABLE6 ;
   i := ComboBox1.ItemIndex ;
   rn:= SInt(GetStrCode(ComboBox1.Items[i]));
   //
   // f[^`FbN
   if not(Form1.CheckValue(t,'N','', n)) then begin
      ShowMessage('͂ԍ͖gpł̂ŕύX͏o܂Bē͂ĉ');
      Edit1.SetFocus ;
      exit ;
   end ;
   //
   SetLength(fs,TABLE6N);
   SetLength(s ,TABLE6N);

   fs[0] := 'N';
   fs[1] := 'ZN';
   fs[2] := 'CONT';
   fs[3] := 'RN';
   fs[4] := 'RDATE';

   s[0] := IntToStr(n) ;
   s[1] := IntToStr(P_CODE2) ;
   s[2] := Edit2.Text ;
   s[3] := IntToStr(rn) ;
   s[4] := Edit3.Text ;

   for i:=2 to 4 do begin
      if (i = 3) then continue ;
      if (s[i] = '') then
         s[i] := 'NULL'
      else
         s[i] := '''' + s[i] + '''' ;
   end;

   w := 'N=' + IntToStr(n) ;

   if (Form1.TableEdit(t,TABLE6N,fs,s,w)) then begin
      ShowMessage('ύXOK');
   end
   else begin
      ShowMessage('ύXs');
   end;

   fs := nil ;
   s  := nil ;

   TableDisplay ;
end;

end.
