unit Unit8;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,
  UnitV, Unit9 ;

type
  TMouPoint = record
    mn : integer ;
    st : integer ;
    mx : integer ;
    my : integer ;
    fm : TForm9 ;
  end;

  TForm8 = class(TForm)
    Label1: TLabel;
    Timer1: TTimer;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private 錾 }
    MouPntN : integer ;
    MouPnt  : array of TMouPoint ;
  public
    { Public 錾 }
    procedure MyMouse(Sender: TObject; stat:integer);
    procedure MouseDisplay(Sender: TObject);
  end;

var
  Form8: TForm8;

implementation

uses
   Unit1 ;

{$R *.dfm}

// N
procedure TForm8.FormShow(Sender: TObject);
begin
   MouPntN := 0 ;
   MouPnt  := nil ;

   MyMouse(Sender,1);   // ̃}EXʒuo^
   //
   Timer1.Interval := TIMERWAIT2 ;
   Timer1.Enabled := True ;
end;

// I
procedure TForm8.FormClose(Sender: TObject; var Action: TCloseAction);
var
   i : integer ;
begin
   Timer1.Enabled := False ;

   MyMouse(Sender,0);   // ̃}EXʒuo^(:)

   for i:=0 to MouPntN-1 do begin
      with mouPnt[i] do begin
         if (st = 1) then begin
            fm.Close ;
            fm := nil ;
         end;
      end;
   end;
   MouPnt := nil ;

   Fm8_fl := False ;

   Action := caFree ;
end;

// ^C}[FXV
procedure TForm8.Timer1Timer(Sender: TObject);
begin
   Timer1.Enabled := False ;

   MyMouse(Sender,1);      // ̃}EXʒuo^
   MouseDisplay(Sender);   // }EX|C^\

   Timer1.Interval := TIMERWAIT2 ;
   Timer1.Enabled := True ;
end;

// ̃}EXʒuo^
//    stat :   0:@1:L
procedure TForm8.MyMouse(Sender: TObject; stat:integer);
var
   fs: array of string ;
   s : array of string ;
begin
   SetLength(fs,TABLE4N);
   SetLength(s ,TABLE4N);
   fs[0] := 'MN';
   fs[1] := 'ST';
   fs[2] := 'MX';
   fs[3] := 'MY';
   s[0]  := IntToStr(PCno) ;
   s[1]  := IntToStr(stat) ;
   s[2]  := IntToStr(Mouse.CursorPos.X - Form1.Left);
   s[3]  := IntToStr(Mouse.CursorPos.Y - Form1.Top );
   if not(Form1.CheckValue(TABLE4,'MN','',PCno)) then
      Form1.TableAdd(TABLE4,TABLE4N,fs,s)
   else
      Form1.TableEdit(TABLE4,TABLE4N,fs,s,'MN='+IntToStr(PCno)) ;
   fs := nil ;
   s  := nil ;
end;

// }EX|C^\
//    PC̃}EXʒuQ
procedure TForm8.MouseDisplay(Sender: TObject);
var
   p,w : string ;
   s : array of string ;
   m,n,i,j,k : integer ;
begin
   // f[^Q
   SetLength(s ,TABLE4N+1);
   p := TABLE4+'.MN,' + TABLE4+'.ST,' + TABLE4+'.MX,' + TABLE4+'.MY,' + TABLE2+'.PNAME' ;
   // w := '';
   w := TABLE4+'.MN<>'+IntToStr(PCno) + ' AND ' ;
   w := w + TABLE4+'.MN=' + TABLE2 + '.N' ;
   m := Form1.TableRef(p,TABLE4+','+TABLE2,w,TABLE4+'.MN');
   for i:=1 to m do begin
      if (i = 1) then
         Form1.TableFirst(s)
      else
         Form1.TableNext(s);
      //
      k := -1 ;
      n := SInt(s[0]);
      for j:=0 to MouPntN-1 do begin
         if (MouPnt[j].mn = n) then begin
            k := j ;
            break ;
         end;
      end;
      if (k = -1) then begin
         if (SInt(s[1]) = 1) then begin
            Inc(MouPntN) ;
            SetLength(MouPnt,MouPntN) ;
            with MouPnt[MouPntN-1] do begin
               mn := n ;
               st := 1 ;
               mx := SInt(s[2]);
               my := SInt(s[3]);
               try
                  fm := TForm9.Create(Application) ;
                  fm.P_NAME := s[4] ;
                  fm.P_COLOR := clAqua ;
                  fm.Show ;
               except
                  fm := nil;
                  st := 0 ;
               end;
            end;
         end;
      end
      else begin
         if (SInt(s[1]) = 1) then begin
            with MouPnt[k] do begin
               if (st = 0) then begin
                  st := 1 ;
                  mx := SInt(s[2]);
                  my := SInt(s[3]);
                  try
                     fm := TForm9.Create(Application) ;
                     fm.P_NAME := s[4] ;
                     fm.P_COLOR := clAqua ;
                     fm.Show ;
                  except
                     fm := nil;
                     st := 0 ;
                  end;
               end
               else begin
                  mx := SInt(s[2]);
                  my := SInt(s[3]);
               end;
            end;
         end
         else begin
            with MouPnt[k] do begin
               if (st = 1) then begin
                  fm.Close ;
                  fm := nil;
                  st := 0 ;
               end;
            end;
         end;
      end;
   end;
   Form1.TableClose ;
   s := nil ;
   // }EXʒu̔f
   // AAʏԂłƂ͌ȂׁA
   // @葤ۂɉĂ̂̓`bgŊmFǂ
   for i:=0 to MouPntN-1 do begin
      with mouPnt[i] do begin
         if (st = 1) then begin
            fm.Left := mx + Form1.Left ;
            fm.Top  := my + Form1.Top  ;
         end;
      end;
   end;
end;


end.
