unit UnitV;

interface

uses
   Windows,Graphics,SysUtils,clipping ;

const
   TABLE1  = 'SECTION' ;   // e[u
   TABLE1N = 2 ;           // tB[h
   TABLE2  = 'MEMBER' ;    // o[e[u
   TABLE2N = 3 ;           // tB[h
   TABLE3  = 'CHAT' ;      // `bgf[^e[u
   TABLE3N = 5 ;           // tB[h
   TABLE4  = 'MOUSEPOS' ;  // }EX|C^f[^e[u
   TABLE4N = 4 ;           // tB[h
   TABLE5  = 'CADLIST' ;   // CAD}ʈꗗe[u
   TABLE5N = 22 ;          // tB[h
   TABLE6  = 'CADREV' ;    // ee[u
   TABLE6N = 5 ;           // tB[h
   TIMERWAIT1 = 5*1000 ;   // `bg@XV^C}[5b
   TIMERWAIT2 = 1*1000 ;   // }EX|C^ XV^C}[1b
   _LIMIT  = 0.00000001;
   _LIMITN = 0.0000000001;

var
   AppPath  : string ;  // vÔtH_@Ō͕Ku\v
   DBserv   : string ;  // T[o[iIPAhX{':'iu192.168.0.0:vj́ulocalhost:vj
   DBfold   : string ;  // T[o[̃f[^̃tH_@Ō͕Ku\vŏIĉBFuC:\data\v
   DBname   : string ;  // f[^x[Xigq́u.FDBvjtH_͕sv@FuPAINT.FDBv
   PCno     : integer ; // PCpҖ̔ԍ
   PCname   : string ;  // PCpҖ
   S_TYPE   : integer ; // P_TYPEւ̎󂯓np
   S_CODE1  : integer ; // P_CODE1ւ̎󂯓np
   S_CODE2  : integer ; // P_CODE2ւ̎󂯓np
   S_CODE3  : integer ; // P_CODE3ւ̎󂯓np
   S_CODEW1 : double ;
   S_CODEW2 : double ;
   Fm6_fl   : Boolean ; // Form6i`bgjʂ\Ă邩ǂidatۑȂj
   Fm6_w    : integer ; // Form6̕
   Fm6_h    : integer ; // Form6̍
   Fm8_fl   : Boolean ; // Form8i}EX|C^jʂ\Ă邩ǂidatۑȂj
   Fm12_w   : integer ; // Form12̕
   Fm12_h   : integer ; // Form12̍
   Fm13_w   : integer ; // Form13̕
   Fm13_h   : integer ; // Form13̍
   Fm12_c   : array[0..12] of integer ; // Form12SG1Z

   function ESCcheck : Boolean ;

   function SInt(s:string):integer ;
   function SFlo(s:string):single ;
   function SDbl(s:string):double ;
   function CheckNum(s:string):Boolean ;
   function MidStr2(S:string; V1,V2:integer;var V3:integer) : string ;
   function QTrim(s:string):string ;
   function HanToZen(s:string):string ;
   function ZenToHan(s:string):string ;
   function GetStrCode(S:string) : String ;
   function GetStrName(S:string) : String ;
   function CheckDate(s:string) : Boolean ;
   function GetNetDrive(drv:string):string;

   function PaperSize(n:integer;var pax,pay:double):string;
	function  Roundoff(V:double) : double ;
	function IRoundoff(V:double) : Integer ;

	procedure GCLS(C:TCanvas;x,y:Integer) ;
	procedure GPenSet(C:TCanvas; col,typ,wid:Integer) ;
	procedure GBrushSet(C:TCanvas;col,typ:Integer) ;
	procedure GCopyMode(C:TCanvas) ;
	procedure GXorMode(C:TCanvas) ;
	procedure GLine(C:TCanvas; x1,y1,x2,y2:Integer);
	procedure GBox (C:TCanvas; x1,y1,x2,y2:Integer);
	procedure GLLine(C:TCanvas; x1,y1,x2,y2 , lsc,clx1,cly1,clx2,cly2:double;phx,phy:integer);

implementation

function ESCcheck : Boolean ;
begin
   Result := False ;
   if ((GetAsyncKeyState(VK_ESCAPE)and $8000)>0) then
      Result := True ;
end;

// ---------- - ---------- - ----------
//       ֐E葱
//       Ƃ̕ϊ֐E葱
// ---------- - ---------- - ----------
// 񁨐
function SInt(s:string):integer ;
var
   a,i : integer ;
begin
   if (s <> '') then begin
      Val(s,a,i);
      if (i <> 0) then
         a := 0;
   end
   else
      a := 0;
   Result := a;
end;

// 񁨎(float(single))
function SFlo(s:string):single ;
var
   a : single ;
   i : integer ;
begin
   if (s <> '') then begin
      Val(s,a,i);
      if (i <> 0) then a := 0.0;
   end
   else
      a := 0.0;
   Result := a;
end;

// 񁨎(double)
function SDbl(s:string):double ;
var
   a : double ;
   i : integer ;
begin
   if (s <> '') then begin
      Val(s,a,i);
      if (i <> 0) then
         a := 0.0;
   end
   else
      a := 0.0;
   Result := a;
end;

// 񂪐ō\Ă邩`FbN
//    ̏ꍇ True ɂȂ
function CheckNum(s:string):Boolean ;
var
   i : integer ;
   ss: string ;
begin
   Result := True ;
   for i:=1 to Length(s) do begin
      ss := Copy(s,i,1);
      if (ss < '0')or(ss > '9') then begin
         Result := False ;
         break ;
      end;
   end;
end;

{ ̎wʒu炎oCgo܂
   in:S  ... ̕
     :V1 ... oJnʒu(1`)
     :V2 ... ooCg
 	out:V3 .. ۂɔooCg
   out: .... o
ŌA̕Ȃ悤ɒ }
function MidStr2(S:string; V1,V2:integer;var V3:integer) : string ;
var s1,s_1 : string ;
   i,l : integer ;
   f:Boolean;
begin
   l := Length(S) ;
   if (S = '')or(V1 < 1)or(V1 > l)or(V2 <= 0) then begin
       Result := '' ;
       V3 := 0;
       exit;
   end;
	s1:='';
   V3:=0;
	i:=1;
	f:=True;
	while(f)do begin
      s_1 := Copy(S,i,2) ;
		if (Ord(s_1[1]) >= 128)and(Ord(s_1[1]) <= 159)
       or(Ord(s_1[1]) >= 224)and(Ord(s_1[1]) <= 253) then begin
			if (i >= V1)and(i+1 <= V1+V2-1) then begin
         	// s1:=s1+S[i]+S[i+1];
            s1 := s1 + s_1 ;
         	V3:=V3+2;
         end;
			i:=i+2;
      end
      else begin
			if (i >= V1)and(i <= V1+V2-1) then begin
         	// s1:=s1+S[i];
            s1 := s1 + s_1[1] ;
         	Inc(V3);
         end;
			Inc(i);
      end;
		if (i > l) then f:=False;
   end;
   Result := s1 ;
end;

// w蕶
//    PpEdpERg[R[h֐
function QTrim(S:String): String ;
var
   i,i1:Integer ;
	ss,r,t : string ;
begin
	r := '' ;
	i := 1 ;
	i1 := Length(S) ;
	while(i <= i1) do begin
      ss := Copy(S,i,2) ;
		if (Ord(ss[1]) >= 128)and(Ord(ss[1]) <= 159)
       or(Ord(ss[1]) >= 224)and(Ord(ss[1]) <= 253) then begin
			if ((i+1)<= i1) then begin
	      	// 
				t := ss ;
				r := r + t ;
				i := i + 2 ;
         end
         else
         	Inc(i);
		end
      else begin
      	// ANK
			t := ss[1] ;
			if (t <> '''')and(t <> '"')and(Ord(ss[1]) >= 32) then r := r + t ;
	      Inc(i);
      end;
   end;
	Result := r ;
end;

// pSp
//    p̍ő啶512܂
function HanToZen(s:string) : string ;
var
   Buf: array[0..1024] of Char;
   r  : string;
begin
   LCMapString(GetUserDefaultLCID,LCMAP_FULLWIDTH or LCMAP_KATAKANA,
      PChar(s), Length(s)+1, Buf, 1024);   // pSp,Ђ灨Ji
   r := string(Buf);
   Result := r;
end;

// Spp
//    Sp̍ő啶͈ꉞ512܂
function ZenToHan(s:string) : string ;
var
   Buf: array[0..1024] of Char;
   r  : string;
begin
   LCMapString(GetUserDefaultLCID,LCMAP_KATAKANA or LCMAP_HALFWIDTH,
      PChar(s), Length(s)+1, Buf, 1024);
   r := string(Buf);
   Result := r;
end;

// u:v`́̕A擾
function GetStrCode(S:string) : String ;
var
   i : Integer ;
begin
   Result := '' ;
   i := AnsiPos(':',S);
   if (i = 0)or(Length(S) = 0) then exit ;

   Result := Copy(S,1,i-1);
end;

// u:v`́̕A擾
function GetStrName(S:string) : String ;
var
   i : Integer ;
begin
   Result := '' ;
   i := AnsiPos(':',S);
   if (i = 0)or(Length(S) = 0) then exit ;

   Result := Copy(S,i+1,Length(S));
end;

// t̃`FbN
//    s : t@yyyymmdd`
// ret
//    True : OK  False : Error
function CheckDate(s:string) : Boolean ;
var
   dd: double ;
begin
   Result := False ;
   if (Length(s) <> 8) then exit ;
   if not(CheckNum(s)) then exit ;
   try
      dd := EncodeDate(SInt(Copy(s,1,4)),SInt(Copy(s,5,2)),SInt(Copy(s,7,2)));
   except
      exit ;
   end;
   if (dd < 0.0) then exit ;
   Result := True ;
end;

// hCů蓖ĂĂ鋤LfBNg擾
//		drv : zhCuiD:AH:AEEEj
//		ret : LfBNg
//				Ⴄꍇ́AhCû܂ܕԂ
function GetNetDrive(drv:string):string;
var
	ShareName: array[0..255] of Char ;
   Size: DWORD;
   s : string ;
begin
	Size := 256;
   if (WNetGetConnection(PChar(drv), ShareName, Size) = NO_ERROR) then
		s := string(ShareName)
   else
		s := drv ;
   Result := s ;
end;

// pTCY
//    n : 1`6:A0`A5@7`12:A0c`A5c
//    px,py : Ec̑傫[mm]
//    ret : uA0v`uA5cv
function PaperSize(n:integer;var pax,pay:double):string;
begin
   Result := 'C';
   pax := 100.0;
   pay := 100.0;
   Case(n)of
    1:   begin
				pax := 1189.0;
				pay :=  841.0;
            Result := 'A0';
         end;
    2:   begin
				pax := 841.0;
				pay := 594.0;
            Result := 'A1';
         end;
    3:   begin
				pax := 594.0;
				pay := 420.0;
            Result := 'A2';
         end;
    4:   begin
				pax := 420.0;
				pay := 297.0;
            Result := 'A3';
         end;
    5:   begin
				pax := 297.0;
				pay := 210.0;
            Result := 'A4';
         end;
    6:   begin
				pax := 210.0;
				pay := 148.0;
            Result := 'A5';
         end;
    7:   begin
				pax :=  841.0;
				pay := 1189.0;
            Result := 'A0c';
         end;
    8:   begin
				pax := 594.0;
				pay := 841.0;
            Result := 'A1c';
         end;
    9:   begin
				pax := 420.0;
				pay := 594.0;
            Result := 'A2c';
         end;
   10:   begin
				pax := 297.0;
				pay := 420.0;
            Result := 'A3c';
         end;
   11:   begin
				pax := 210.0;
				pay := 297.0;
            Result := 'A4c';
         end;
   12:   begin
				pax := 148.0;
				pay := 210.0;
            Result := 'A5c';
         end;
   end;
end;

{ ľܓ }
function Roundoff(V:double) : double ;
begin
	if (V >= 0) then
		Result := Trunc(V + 0.5)
	else
   	Result := Trunc(V - 0.5);
end;

{ ľܓ }
function IRoundoff(V:double) : Integer ;
begin
	if (V >= 0) then
		Result := Integer(Trunc(V + 0.5))
	else
   	Result := Integer(Trunc(V - 0.5));
end;

// ---------- - ---------- - ----------
//       OtBbN֐E葱
// ---------- - ---------- - ----------

// ʃNAiwiFj
procedure GCLS(C:TCanvas;x,y:Integer) ;
begin
	with C do begin
      Pen.Mode    := pmCopy ;
      Pen.Width   := 1 ;
      Pen.Color	:= clWhite ;
  	   Brush.Color := clWhite ;
      Brush.Style := bsSolid ;
		Rectangle(0,0,x,y);
		Brush.Style := bsClear ;
	end;
end;

{ y̐ݒ
		col : F
		typ : No.
      wid : [dot] }
procedure GPenSet(C:TCanvas; col,typ,wid:Integer) ;
begin
	with C do begin
		Brush.Style := bsClear ;
		Pen.Color	:= col ;
		Pen.Width	:= wid ;
		Case (typ) of
		1 : Pen.Style := psDash	;
  		2 : Pen.Style := psDot ;
		3 : Pen.Style := psDashDot ;
		4 : Pen.Style := psDashDotDot ;
		5 : Pen.Style := psClear ;
		else
  	   	 Pen.Style := psSolid ;
		end;
	end;
end;

{ uV̐ݒ
		col : F
		typ : 0: 1:x^ 2: 3:
      		4:ΐ_ 5:ΐE^ 6:NX{ 7:NX~ }
procedure GBrushSet(C:TCanvas;col,typ:Integer) ;
begin
	with C.Brush do begin
		Color := col ;
		Case (typ) of
		1:	Style := bsSolid;			// ׂh
	   2:	Style := bsHorizontal;	// 
	   3:	Style := bsVertical;		// 
	   4:	Style := bsFDiagonal;	// ΐ	オ_
	   5:	Style := bsBDiagonal;	// ΐ@Eオ^
	   6:	Style := bsCross;			// NX
	   7:	Style := bsDiagCross;	// NXΐ
		else
      	Style := bsClear;			// 
		end;
   end;
end;

{ y}[hRs[[hɂ }
{		ʏ̊G }
procedure GCopyMode(C:TCanvas) ;
begin
	C.Pen.Mode := pmCopy ;
end;

{ y}[hXOR[hɂ }
{		o[{bNXQx`ď[h }
procedure GXorMode(C:TCanvas) ;
begin
	C.Pen.Mode := pmXor ;
end;

{ `
		x1,y1 : Jn_
		x2,y2 : I_ }
procedure GLine(C:TCanvas; x1,y1,x2,y2:Integer);
begin
	with C do begin
   	MoveTo(x1,y1);
     	LineTo(x2,y2);
   	Pixels[x2,y2] := Pen.Color ;
	end;
end;

{ ``
		x1,y1 : Jn_
		x2,y2 : I_ }
procedure GBox(C:TCanvas; x1,y1,x2,y2:Integer);
begin
	if (Abs(x1-x2) <= 2)and(Abs(y1-y2) <= 2) then exit ;
	if (Abs(x1-x2) <= 2) then begin
   	GLine(C,x1,y1,x1,y2);
   end
   else if (Abs(y1-y2) <= 2) then begin
   	GLine(C,x1,y1,x2,y1);
   end
   else begin
		with C do begin
   		Rectangle(x1,y1,x2,y2);
		end;
   end;
end;

{ _Wɂ钼`
		x1,y1 : Jn_
		x2,y2 : I_ }
procedure GLLine(C:TCanvas; x1,y1,x2,y2 , lsc,clx1,cly1,clx2,cly2:double;phx,phy:integer);
var
	i : integer ;
	ix1,iy1,ix2,iy2 : integer ;
	w1,w2 : double ;
begin
	i := ClipLine(x1,y1,x2,y2 , clx1,cly1,clx2,cly2) ;
	if (i = 2) then exit ;
	w1 := (x1 - clx1)*lsc ;
	w2 := (y1 - cly1)*lsc ;
   ix1 := IRoundoff(w1) ;
   iy1 := phy - IRoundoff(w2) ;
   w1 := (x2 - clx1)*lsc ;
	w2 := (y2 - cly1)*lsc ;
   ix2 := IRoundoff(w1) ;
   iy2 := phy - IRoundoff(w2) ;
	GLine(C, ix1,iy1,ix2,iy2);
end;

end.
