// NbsOs֐
unit clipping;

interface
	function ClipSub(x,y,wx1,wy1,wx2,wy2:double):integer ;
	function ClipAreaOut(var vx,vy:double;x,y,wx1,wy1,wx2,wy2:double):integer ;
   function ClipPoint(x1,y1,wx1,wy1,wx2,wy2:double):Integer ;
	function Clip2Point(x1,y1,x2,y2,wx1,wy1,wx2,wy2:double):Integer ;
   function ClipPreLine(x1,y1,x2,y2:double;wx1,wy1,wx2,wy2:double):Integer ;
   function ClipLine(var x1,y1,x2,y2:double;wx1,wy1,wx2,wy2:double):Integer ;

implementation

const
   LIMITN_ = 0.000000000001 ;

{ NbsOTu }
{     WEChEɂ邩ǂ`FbN }
{     x,y:point }
{     wx1 < wx2 , wy1 < wy2  }
{     ret : 0 : g }
{           : gO }
function ClipSub(x,y,wx1,wy1,wx2,wy2:double):integer ;
var c : integer ;
begin
   c := 0 ;
   if ((y-wy2) > -LIMITN_) then c := c or 8 ;
   if ((y-wy1) <  LIMITN_) then c := c or 4 ;
   if ((x-wx2) > -LIMITN_) then c := c or 2 ;
   if ((x-wx1) <  LIMITN_) then c := c or 1 ;
   Result := c ;
end;

{ ͈͊O̓_̋EEChE_ }
{  vx,vy : (out) EEChE_ }
{	x ,y  : (inp) point }
{     wx1 < wx2 , wy1 < wy2  }
{     ret : 0 :  }
{           1 :  2:E 3: 4:E }
function ClipAreaOut(var vx,vy:double;x,y,wx1,wy1,wx2,wy2:double):integer ;
var c : integer ;
begin
	Result := 0 ;
   vx := 0.0 ;
   vy := 0.0 ;
   c := ClipSub(x,y,wx1,wy1,wx2,wy2) ;
	if (c = 5) then begin
   	Result := 1 ;
      vx := wx1 ;
      vy := wy1 ;
   end
   else if (c = 6) then begin
   	Result := 2 ;
      vx := wx2 ;
      vy := wy1 ;
   end
   else if (c = 9) then begin
   	Result := 3 ;
      vx := wx1 ;
      vy := wy2 ;
   end
   else if (c = 10) then begin
   	Result := 4 ;
      vx := wx2 ;
      vy := wy2 ;
   end;
end;

{ _̃NbsO`FbN }
{     x1,y1:point }
{     wx1 < wx2 , wy1 < wy2  }
{     0 : g }
{     2 : gO }
function ClipPoint(x1,y1,wx1,wy1,wx2,wy2:double):Integer ;
var c : integer ;
begin
   c := ClipSub(x1,y1,wx1,wy1,wx2,wy2) ;
   if (c = 0) then
      Result := 0
   else
      Result := 2 ;
end;

{ Q_̃NbsO`FbN }
{     x1,y1:start point , x2,y2:end point }
{     wx1 < wx2 , wy1 < wy2  }
{     0 : g }
{     1 : NbsOΏ }
{     2 : gO }
function Clip2Point(x1,y1,x2,y2,wx1,wy1,wx2,wy2:double):Integer ;
var c1,c2 : integer ;
begin
   c1 := ClipSub(x1,y1,wx1,wy1,wx2,wy2) ;
   c2 := ClipSub(x2,y2,wx1,wy1,wx2,wy2) ;
   if (c1 = c2)and(c1 = 0) then begin
      Result := 0 ;
      exit ;
   end;
   if ((c1 and c2) > 0) then begin
      Result := 2 ;
      exit ;
   end ;
   Result := 1 ;
end;

{ ̃NbsO`FbN }
{     x1,y1:start point , x2,y2:end point }
{     wx1 < wx2 , wy1 < wy2  }
{     0 : g }
{     1 : NbsOΏ }
{     2 : gO }
{		W̓ւ͍sȂ }
function ClipPreLine(x1,y1,x2,y2,wx1,wy1,wx2,wy2:double):Integer ;
var
	w1,w2,w3,w4 : double ;
begin
	w1 := x1;
   w2 := y1;
   w3 := x2;
   w4 := y2;
   Result := ClipLine(w1,w2,w3,w4,wx1,wy1,wx2,wy2);
end;

{ ̃NbsO }
{     x1,y1:start point , x2,y2:end point }
{     wx1 < wx2 , wy1 < wy2  }
{     0 : g }
{     1 : NbsOΏ }
{     2 : gO }
function ClipLine(var x1,y1,x2,y2:double;wx1,wy1,wx2,wy2:double):Integer ;
var c1,c2 : integer ;
   a,b,dx,dy : double ;
begin
   c1 := ClipSub(x1,y1,wx1,wy1,wx2,wy2) ;
   c2 := ClipSub(x2,y2,wx1,wy1,wx2,wy2) ;
   if (c1 = c2)and(c1 = 0) then begin
      Result := 0 ;
      exit ;
   end;
   if ((c1 and c2) > 0) then begin
      Result := 2 ;
      exit ;
   end ;
   Result := 1 ;

   a  := x1 ;
   b  := y1 ;
   dx := x2 - x1 ;
   dy := y2 - y1 ;

   if ((c1 and 1) > 0) then begin
      if (Abs(dx) > LIMITN_) then begin
         x1 := wx1 ;
         y1 := (x1-a)*dy/dx + b ;
         c1 := ClipSub(x1,y1,wx1,wy1,wx2,wy2) ;
      end ;
   end ;
   if ((c1 and 2) > 0) then begin
      if (Abs(dx) > LIMITN_) then begin
         x1 := wx2 ;
         y1 := (x1-a)*dy/dx + b ;
         c1 := ClipSub(x1,y1,wx1,wy1,wx2,wy2) ;
      end ;
   end ;
   if ((c1 and 4) > 0) then begin
      if (Abs(dy) > LIMITN_) then begin
         y1 := wy1 ;
         x1 := (y1-b)*dx/dy + a ;
         c1 := ClipSub(x1,y1,wx1,wy1,wx2,wy2) ;
      end ;
   end ;
   if ((c1 and 8) > 0) then begin
      if (Abs(dy) > LIMITN_) then begin
         y1 := wy2 ;
         x1 := (y1-b)*dx/dy + a ;
         ClipSub(x1,y1,wx1,wy1,wx2,wy2) ;
      end ;
   end ;

   if ((c2 and 1) > 0) then begin
      if (Abs(dx) > LIMITN_) then begin
         x2 := wx1 ;
         y2 := (x2-a)*dy/dx + b ;
         c2 := ClipSub(x2,y2,wx1,wy1,wx2,wy2) ;
      end ;
   end ;
   if ((c2 and 2) > 0) then begin
      if (Abs(dx) > LIMITN_) then begin
         x2 := wx2 ;
         y2 := (x2-a)*dy/dx + b ;
         c2 := ClipSub(x2,y2,wx1,wy1,wx2,wy2) ;
      end ;
   end ;
   if ((c2 and 4) > 0) then begin
      if (Abs(dy) > LIMITN_) then begin
         y2 := wy1 ;
         x2 := (y2-b)*dx/dy + a ;
         c2 := ClipSub(x2,y2,wx1,wy1,wx2,wy2) ;
      end ;
   end ;
   if ((c2 and 8) > 0) then begin
      if (Abs(dy) > LIMITN_) then begin
         y2 := wy2 ;
         x2 := (y2-b)*dx/dy + a ;
         ClipSub(x2,y2,wx1,wy1,wx2,wy2) ;
      end ;
   end ;

   if (Abs(x2-x1) < LIMITN_)
   and(Abs(y2-y1) < LIMITN_) then Result := 2 ;
end;

end.
